import type { Optional } from '../../../utils/type';
import type { IndyProofRequest } from 'indy-sdk';
import { RevocationInterval } from '../../credentials';
import { ProofAttributeInfo } from './ProofAttributeInfo';
import { ProofPredicateInfo } from './ProofPredicateInfo';
/**
 * Proof Request for Indy based proof format
 *
 * @see https://github.com/hyperledger/indy-sdk/blob/57dcdae74164d1c7aa06f2cccecaae121cefac25/libindy/src/api/anoncreds.rs#L1222-L1239
 */
export declare class ProofRequest {
    constructor(options: Optional<Omit<ProofRequest, 'toJSON'>, 'requestedAttributes' | 'requestedPredicates'>);
    name: string;
    version: string;
    nonce: string;
    requestedAttributes: Record<string, ProofAttributeInfo>;
    requestedPredicates: Record<string, ProofPredicateInfo>;
    nonRevoked?: RevocationInterval;
    ver?: '1.0' | '2.0';
    toJSON(): IndyProofRequest;
}
